SystemOrganization addCategory: #'JQueryMobile-Core-Document'!

!GRPackage class methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/29/2011 18:46'!
jQueryMobileCoreDocument
	^ self new
		name: 'JQueryMobile-Core-Document';
		description: 'jQueryMobile root renderer';
		addDependency:  'Seaside-Core';
		addDependency: 'Seaside-Session';
		addDependency:  'JQueryMobile-Libraries';
		addDependency: 'JQueryMobile-Scripting';
		url: #seasideUrl;
		yourself! !

!WASession methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/28/2011 11:34'!
nextPageId
	| pageId |
	pageId :=  self properties at: #pageId ifAbsent: [ 0 ].
	pageId := pageId + 1.
	self properties at: #pageId put: pageId.
	
	^ 'pageId', pageId greaseString! !

WAHtmlRoot subclass: #JQMHtmlRoot
	instanceVariableNames: 'pageDivAttributes mobileInit redirect includeDataUrl pageId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Core-Document'!

!JQMHtmlRoot commentStamp: 'NickAger 11/1/2011 00:10' prior: 0!
JQMHtmlRoot supports mobileinit and ensures each page is wrapped in a page div with a unique page id applied!

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 11/28/2011 17:48'!
addJQueryMobileHeadInfoUsing: rootForScriptRendering
	"see: http://jquerymobile.com/test/docs/pages/page-anatomy.html"
	
	"A jQuery Mobile site must start with an HTML5 'doctype' to take full advantage of all of the framework's features."
	self beHtml5. 
	
	"jQueryMobile is dependant on a specific version of jQuery - hardcode that version here."
	rootForScriptRendering javascript url: 'https://ajax.googleapis.com/ajax/libs/jquery/1.6.4/jquery.min.js'.
	"mobileInit appears before the jQueryMobile library so that it can modify the defaults"
	self renderMobileInitOn: rootForScriptRendering.
	JQMDeploymentLibrary default updateRoot: rootForScriptRendering.
	
	"The viewport setting below ensures the width will be set to the pixel width of the device screen"
	self meta name: 'viewport'; content: 'width=device-width, initial-scale=1'! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 10:24'!
closeOn: aDocument
	aDocument scriptGenerator
		close: self on: aDocument pageId: self pageId.
	self writeFootOn: aDocument! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 10:11'!
closePageDivOn: aDocument
	aDocument closeTag: 'div'! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:51'!
includeDataUrl
	"data-url attribute in the page's div.
	enable data-url if you want the browser's address bar to reflect the page's url after Seaside's
	redirect. Important for restful pages or avoiding firing callbacks when the user hits refresh
	http://jquerymobile.com/test/docs/pages/page-links.html"
	^ includeDataUrl ifNil: [ includeDataUrl := false ]! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:51'!
includeDataUrl: anObject
	"data-url attribute in the page's div.
	enable data-url if you want the browser's address bar to reflect the page's url after Seaside's
	redirect. Important for restful pages or avoiding firing callbacks when the user hits refresh
	http://jquerymobile.com/test/docs/pages/page-links.html"
	includeDataUrl := anObject! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:53'!
mobileInit
	"http://jquerymobile.com/test/docs/api/globalconfig.html
	http://localhost:8080/javascript/jquery-mobile/Configuring-defaults"
	^ mobileInit! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:53'!
mobileInit: anObject
	"http://jquerymobile.com/test/docs/api/globalconfig.html
	http://localhost:8080/javascript/jquery-mobile/Configuring-defaults"
	mobileInit := anObject! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 09:08'!
pageDivAttributes
	^ pageDivAttributes ifNil: [
		pageDivAttributes := WAHtmlAttributes new
			at: 'data-role' put: 'page';
			yourself ]
! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/28/2011 10:17'!
pageId
	^ pageId ifNil: [ pageId := self session nextPageId ]! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:53'!
redirect
	"Seaside's redirect enable/disable"
	^ redirect ifNil: [ redirect := true ]! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/27/2011 00:53'!
redirect: anObject
	"Seaside's redirect enable/disable"
	redirect := anObject! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 20:05'!
renderJQueryMobileHeadInfo
	| rootForScriptRendering |
	"create another root so that we can ensure the jQuery libraries are the first libraries rendered in the root block"
	rootForScriptRendering := self class context: self context.
	
	self addJQueryMobileHeadInfoUsing: rootForScriptRendering.
	
	rootForScriptRendering headElements reverse do: [ :each |
		self headElements addFirst: each ]! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 20:03'!
renderMobileInitOn: rootForScriptRendering
	self mobileInit notNil ifTrue: [
		String streamContents: [ :stream |
			| document |
			document := WAHtmlDocument
				on: stream
				codec: self requestContext codec.
			self context document: document during: [ 
				| innerScript outerScript |
				innerScript := (JSScript context: self context)
					rendererClass: WARenderer;
					yourself.
					
				outerScript := (JSScript context: self context)
					rendererClass: WARenderer;
					yourself.

				self mobileInit value: innerScript.
				outerScript << outerScript jQuery jqmDocument onMobileInit: innerScript.
				rootForScriptRendering javascript add: outerScript asJavascript ] ] ]! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 21:08'!
seasideAjaxRequestHeaderNoRedirect
	^ '$($("html").ajaxSend(function(event, xhr, settings) {  settings.url += "&_n"; xhr.setRequestHeader("X-Requested-With", "jQueryMobile") }))'! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 21:06'!
seasideAjaxRequestHeaderWithRedirect
	^ '$($("html").ajaxSend(function(event, xhr, settings) { xhr.setRequestHeader("X-Requested-With", "jQueryMobile") }))'! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 10:11'!
writeFootOn: aDocument
	self closePageDivOn: aDocument.
	super writeFootOn: aDocument! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 10:18'!
writeHeadOn: aDocument
	self renderJQueryMobileHeadInfo.
	super writeHeadOn: aDocument.
	self writeSeasideAjaxRequestHeaderOn: aDocument.
	self writePageDivOn: aDocument! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/28/2011 10:18'!
writePageDivOn: aDocument
	| attributes |
	attributes := self pageDivAttributes.
	attributes at: 'id' put: self pageId.
	
	aDocument nextPutAll: '<div'.
	attributes encodeOn: aDocument.

	self includeDataUrl ifTrue: [
		"*Linking page>http://jquerymobile.com/test/docs/pages/page-links.html*"
		"jQueryMobile will update the URL with the url stored in 'data-url', when attached to the page's div. 
		This allows JQueryMobile to reflect redirects, see also: https://github.com/jquery/jquery-mobile/issues/1571"
	
		"add directly to the stream so that url parameters such as & aren't encoded as &amp;"
		aDocument 
			nextPutAll: ' data-url="';
			nextPutAll: self requestContext request url greaseString;
			nextPut: $" ].

	aDocument nextPutAll: '>'
! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 21:11'!
writeSeasideAjaxRequestHeaderOn: aDocument
	aDocument scriptGenerator 
		writeScriptTag: [ 
			self redirect 
				ifTrue: [
					aDocument nextPutAll: self seasideAjaxRequestHeaderWithRedirect ]
				ifFalse: [
					aDocument nextPutAll: self seasideAjaxRequestHeaderNoRedirect ] ]
		on: aDocument! !

!WADocument methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/28/2011 10:48'!
root
	^ root! !
